class CRUD {
    constructor( url ){
        this.url = url;
    }

    set url( url ){
        this._url = url;
    }

    get url() {
        return this._url;
    }

    create( name, data, sid ) {
        return name + data + sid;
    }

    read( uri, sid ) {
        return uri + sid;
    }

    update( uri, sid ) {
        return uri + sid;
    }
    
    delete( uri, sid ) {
        return uri + sid;
    }
}

class TGCrud extends CRUD{
    constructor( url ){
        super( url );
    }

    readData( uri, sid ) {
        return uri + sid;
    }

    readMetadata( uri, sid ){
        let _sid = sid ? '?sessionId=' + sid : '';
        return $.ajax({
          url: this.url + '/' + uri + '/metadata' + _sid,
          type: 'GET',
          crossDomain: true,
          contentType: "json",
        })
    }
}

class TriviaCrud extends CRUD{
    constructor( url ){
        super( url );
    }

    readData( uri, sid ){
        let _sid = sid ? '?sid=' + sid : '';
        return $.ajax({
          url: this.url + '/' + uri + '/data' + _sid,
          type: 'GET',
          crossDomain: true,
        })
    }

    readMetadata( uri, sid ) {
        return uri + sid;
    }
}    

class TriviaClient {
  constructor( sid ){
    this.sid = sid;
    this.api = {};
    this.project = {};
    this.resources = {};
  }

  set crud( url ) {
      this._crud = new TGCrud( url );
  }

  get crud () {
      return this._crud;
  }

  set sid( sid ) {
      this._sid = sid
  }

  get sid() {
      return this._sid;
  }

  addApi( name, crud ) {
    this.api[ name ] = crud;
  } 

  addProject( name, projectId ) {   
    this.project[ name ] = projectId;

  }

  readTriviaResource( uri ) {
    let metadata = this.crud.readMetadata( uri, this.sid );
    metadata
        .done(function (data){
            console.log( data );
        })
        .fail( function(error){
            console.log( error );
        })
    
    // return this.middleware.trivia.readData( uri, this.sid)
    //     .done( (data) => {
    //         console.log( data );
    //     })
    //     .fail( (err) => {
    //         console.log( err );
    //     })
  }

}

class Client{
    constructor( url, sid ){
        this.crud = url;
        this.sid = sid;
    }

    set crud( crud ){
        this._crud = crud;
    }

    get crud(){
        return this._crud;
    }

    set sid( sid ) {
        this._sid = sid
    }
  
    get sid() {
        return this._sid;
    }
}





let conf = {
    "pid" : "TGPR-27cd40b2-1556-3cae-0f9f-5bf29f35397a",
    "sid" : "cxKgCF0HYxWImEmBn9PLEPY8rhKU8Hk3Xo4PpR3q7EhAfAnTA994u6mr1554879267023764",
    "tgCrud" : "https://textgridlab.org/1.0/tgcrud/rest",
    "aggregations" : {
    "trivia" : "textgrid:3r345.0"
    }
}

/* let client = new TextGridClient( conf.tgCrud )
client.sid = conf.sid;
client.addMiddleware( 'trivia', new TriviaCrud('http://localhost:8080/exist/restxq/trivia/1.1/textgrid/crud') )
let res = client.readTriviaResource( 'textgrid:3r3p5' );
res */

let tgCrud = new TGCrud( conf.tgCrud );
let triviaCrud = new TriviaCrud( 'http://localhost:8080/exist/restxq/trivia/1.1/textgrid/crud' );
tgCrud.readMetadata( 'textgrid:3r3p5', conf.sid ).done( function(data){ console.log("done"); console.log(data) })
triviaCrud.readData( 'textgrid:3r3p5', conf.sid ).done( function(data){ console.log("done"); console.log(data) })
