xquery version "3.1";

import module namespace via="http://dev.met.de/via/main" at "xmldb:exist:///db/apps/via/modules/via.xqm";
import module namespace config="http://dev.met.de/via/config" at "xmldb:exist:///db/apps/via/modules/config.xqm";
import module namespace console="http://exist-db.org/xquery/console";
import module namespace tgclient="https://sade.textgrid.de/ns/tgclient" at "xmldb:exist:///db/apps/via/modules/tgclient.xqm";
declare default element namespace "http://dev.met.de/via/";
declare namespace vias="http://dev.met.de/via/schema";
declare namespace svg="http://www.w3.org/2000/svg";
declare namespace tei="http://www.tei-c.org/ns/1.0";
declare namespace tg="http://wwwtextgrid.de";
declare namespace xlink="http://www.w3.org/1999/xlink";


declare namespace output = "http://www.w3.org/2010/xslt-xquery-serialization";
declare option exist:serialize "method=json media-type=application/json";


(:  :let $json := util:binary-doc($config:app-root||"/data/json/sample.1.json"):)




let $parsed := parse-json( $via:json-sample ) 
let $image := via:get-via-surfaces($parsed)[2]
let $shape-object := via:convert-via-surface-to-shapes-surface($image)

let $shape-xml := via:create-shapes-surface-xml-object($shape-object)
let $tble-object := via:create-tble-object($shape-xml)
let $back := via:convert-tble-object-to-shapes-surface($tble-object)
let $original := via:convert-shapes-surface-to-via-surface($back)

let $xml := <annotation target="shape_region2">
                <name>mein kreis</name>
                <type>human</type>
                <image_quality>
                    <frontal>true</frontal>
                    <good>true</good>
                </image_quality>
            </annotation>
            
let $map1 := map{"test" : "uwe", "nr" : 1}
let $map2 := map{"uwe" : "test", "nr" : 2}
let $merge := via:map-merge($map1, $map2)
let $json :=  via:map-to-json($original)

return $original